if Version() < 115 then
    print "Upgrade the Vectrex32 firmware to version 1.15 or newer."
    stop
endif

call SetFrameRate(60)
scorearray = {7,11,17,23}
expl3 = Explosion($19, $3f, 0, 1) 
expl2 = Explosion($19, $3f, 0, 2) 
shotsnd = Explosion($3f, $3f, 0, $80)
joystick = JoystickDigital
highscore = 0
score = 0
combinations = {{1,1,1}}
for cca = 1 to 4
	for ccb = 1 to 4
		for ccc = 1 to 4
			combinations = AppendArrays(combinations,{{cca,ccb,ccc}})
		next ccc
	next ccb
next cca
firing = 0
game = 0
pause = 0

'--------------DEBUGGING-------------------
'Release: 0 = No sound, No stars, Auto-Play
'Release: 1 = Normal Play
'Release: 2 = Auto-Play, Sound, Stars
release = 1

'Outer Loop	
while 1 do
	game = game + 1
	joystick = JoystickDigital
	if (release = 1) then
		call titlescreen()
	endif
	' Wait until buttons 1 and 2 are not pressed
	repeat
		controls = WaitForFrame(JoystickNone, Controller1, JoystickNone)
	until controls[1, 3] = 0 and controls[1, 4] = 0		
	call ClearScreen()

	cameraTrans = {0, 0, 0}
	call CameraTranslate(cameraTrans)
	call Randomize
	call ScaleSprite(64, 324 / 0.097)
	call ReturnToOriginSprite()

	' Initialize Projectiles
	dim shot[8]
	shot[8] = IntensitySprite(130)
	shot[1] = Lines3DSprite(arrow())
	shot[2] = 0
	shot[3] = 0
	shot[4] = 0
	shot[6] = 0
	shot[7] = 0
	call ReturnToOriginSprite();
	shot[5] = Lines3DSprite(arrow())
	call spritetranslate(shot[1],{shot[2],shot[3],shot[4]})
	call SpriteEnable(shot[1],false)
	call spritetranslate(shot[5],{shot[2],shot[3],shot[4]})
	call SpriteEnable(shot[5],false)
	
	' Initialize Variables
	reticlex = 0
	reticley = 0
	delay = 5
	speed = 0.3
	fade = 0
	past = 0
	miss = 3
	score = 0
	lives = 10
	round = 1
	warp = -1
	dim show[3]
	show[1] = 1
	show[2] = 1
	show[3] = 1
	shieldcount = 520
	shieldstatus = 0
	
	'Initialize HUD
	call ReturnToOriginSprite()
	HUDtextSize = {40,5}
	call intensitysprite(70)
	hud = { {-5,110, game+"-"+round},_
			{-80,120, score + ""},_
			{0,127, int(shieldcount/33.3) + ""},_
			{80,120, lives + ""}}
	call TextSizeSprite(HUDtextSize)
	ts = Text2ListSprite(hud)
	call SpriteSetMagnification(ts,1.5)	

	' Initialize Starfield & Reticle
	call intensitysprite(70)
	reticle = NewReticle()
	call spritetranslate(reticle,{0,0,20})
	stars = StarField(release)

	' Initialize Shield
	call ReturnToOriginSprite()
	call IntensitySprite(70)
	shield = Lines3DSprite(makescreen())
	call spritetranslate(shield,{0,-1,0})
	call spriteenable(shield,false)
	
	' Initialize Ships
	firstmodel = rand() mod 3
	'cc = 1+(rand() mod 64)
	'ships = NewShip(1,combinations[cc,1],firstmodel)
	'ships = AppendArrays(ships, NewShip(1,combinations[cc,2],firstmodel))
	'ships = AppendArrays(ships, NewShip(1,combinations[cc,3],firstmodel))
	cc = 1+(rand() mod 4)
	ships = NewShip(1,cc,firstmodel)
	if ((cc + 1) > 4) then
		cc = 1
	else
		cc = cc + 1
	endif
	ships = AppendArrays(ships, NewShip(1,cc,firstmodel))
	if ((cc + 1) > 4) then
		cc = 1
	else
		cc = cc + 1
	endif
	ships = AppendArrays(ships, NewShip(1,cc,firstmodel))
	
	'NB: No ships are showing yet - ships are displayed at the beginning of the Advance Ships loop
	
	while 1 do
		'Update HUD
		hud[1,3] = game + "-" + round
		hud[2,3] = score + ""
		hud[3,3] = int(shieldcount/33.3) + ""
		hud[4,3] = lives + ""
		startTick = GetTickCount()
		controls = WaitForFrame(joystick, Controller1, JoystickX + JoystickY,1)
		
		if (release != 1 AND GetTickCount() - startTick > 480) then
			BP
		endif
		
		'Exit on Button 4
		if controls[1, 6] then
			stop
		endif
		
		'Aim Reticle
		if controls[1, 1] < 0 AND reticlex > -3 then
			reticlex = reticlex - 0.15
		elseif controls[1, 1] > 0 AND reticlex < 3 then
			reticlex = reticlex + 0.15
		endif
		
		if controls[1,2] < 0 AND reticley > -4 then
			reticley = reticley - 0.15
		elseif controls[1,2] > 0 AND reticley < 4 then
			reticley = reticley + 0.15
		endif

		if (joystick = JoystickAnalog) then
			reticlex = 3 * (controls[1,1]/128.0)
			reticley = 4 * (controls[1,2]/128.0)
		endif
		
		call spritetranslate(reticle,{reticlex,reticley,20})
		
		'Draw Shield
		if (controls[1, 4] AND shieldcount > 0) then
			call SpriteEnable(shield, true)
			shieldstatus = 1
		else
			call SpriteEnable(shield, false)
			shieldstatus = 0
		endif
		
		if (shieldstatus = 1 AND shieldcount > 0) then
			shieldcount = shieldcount - 1
		endif

		'Advance Stars
		if (release) then
			delay = delay - 1
			if (delay = 0 OR (warp > 0 AND miss > 0)) then
				delay = 2
				for s = 1 to UBound(stars)
					if (stars[s,4] > 120)
						stars[s,4] = 1
						stars[s,2] = rand() mod 10 - 5
						stars[s,3] = rand() mod 10 - 5
					elseif (warp > 0 AND miss > 0)
						stars[s,4] = stars[s,4] + 25
					else
						stars[s,4] = stars[s,4] + 5
					endif
					call spritetranslate(stars[s,1],{stars[s,2],stars[s,3],stars[s,4]})
				next s
			endif
		endif
		
		'Fire Guns
		if ((release != 1 OR controls[1, 3]) AND shot[4] = 0 AND firing = 0) then
			firing = 1
			call SpriteEnable(shot[1],true)
			call SpriteEnable(shot[5],true)
			shot[2] = 0
			shot[3] = -3
			shot[4] = 1
			shot[6] = 8.0 * (reticlex/3.0)
			shot[7] = 10.0 * (reticley/4.0)
		elseif controls[1,3] = 0 AND shot[4] = 0 then
			firing = 0
		endif
		
		'Advance Shots & Hit Test
		target = 1
		if (shot[4] > 0) then
			shot[4] = shot[4] + 10.0
			depth = ((cos(shot[7]*pi/180)) * shot[4])
			
			shot[2] = shot[2] + ((sin(shot[6]*pi/180)) * 10.0)
			shot[3] = shot[3] + ((sin(shot[7]*pi/180)) * 10.0)
			if (shot[4] > 200) then
				shot[4] = 0
				call SpriteEnable(shot[1],false)
				call SpriteEnable(shot[5],false)
			else
				call spritetranslate(shot[1],{shot[2]-3,shot[3],depth})
				call spritetranslate(shot[5],{shot[2]+3,shot[3],depth})
				call spritesetrotation(shot[1],30,35,0)
				call spritesetrotation(shot[5],30,-35,0)
				call SpriteIntensity(shot[8],80)
				if release then
					call play(shotsnd)
				endif
			endif
			for p = 1 to UBound(ships)
				if (shot[4] > 0 AND _
				ships[p,13] <= 0 AND _
				show[p] = 1 AND _
				abs(shot[2]-ships[p,5]) < target AND _
				abs(shot[3]-ships[p,6])-3 < target AND _
				abs(shot[4]-ships[p,7])-3 < target*3 ) then
					ships[p,13] = 270
					shot[4] = 0
					call SpriteEnable(shot[1],false)			
					call SpriteEnable(shot[5],false)
					call SpriteEnable(ships[p,12], true)			
					call SpriteIntensity(ships[p,14],100)
					p = 4
					if (release) then
						call Play(expl2)
					endif
				endif
			next p
		endif	

		'Advance Ships Loop
		'If a ship's [13] is negative, it means that the ship has bounced and is drifting away.
		'If a ship's [13] is positive, it means that the ship has been hit and is exploding.
		'If a ship's [13] is zero, it means that the ship is approaching.
				
		swoop = false
		for i = 1 to UBound(ships)
			call SpriteEnable(ships[i,ships[i,1]], true)					
			'Bounce
			if (ships[i,13] < 0) then
				ships[i,7] = ships[i,7] + 2
				ships[i,3] = ships[i,3] - 5
				ships[i,2] = ships[i,2] - 10
				ships[i,4] = ships[i,4] - 5

				if (ships[i,7] >= 120) then
					call Play(nil)
					show[i] = 0
					past = past + 1
					miss = miss - 1
					ships[i,13] = 0
					call SpriteIntensity(ships[i,15], 0)
					call SpriteIntensity(ships[i,14], 0)
					call SpriteEnable(ships[i,12], false)
				endif
			endif
			
			'Destroy
			if (ships[i,13] > 0) then
				ships[i,13] = ships[i,13] + 2
				call SpriteIntensity(ships[i,15], 0)
				call SpriteSetMagnification(ships[i,12],cos(ships[i,13]*pi/180)*5)
				call SpriteIntensity(ships[i,14],100-(cos(ships[i,13]*pi/180)*100))
				if (ships[i,13] >= 360) then
					call SpriteIntensity(ships[i,14],0)
					call SpriteEnable(ships[i,12], false)
					show[i] = 0
					past = past + 1
					miss = miss - 1
					ships[i,13] = 0
					score = score + scorearray[(speed*10)-2]
					if (score > highscore)
						highscore = score
					endif
				endif
			endif
			
			'Steer and Advance
			if (show[i] = 1) then
			
				'back wall maneuvering
				dy = ships[i,9] - ships[i,6]
				dx = ships[i,8] - ships[i,5]
				if (ships[i,10] > sqrt((dy*dy)+(dx*dx)))
					ships[i,10] = sqrt((dy*dy)+(dx*dx))
				endif
				if (ships[i,10] >= 2) then
					complete = (ships[i,10]/ships[i,11])
					a = (atan2(dy, dx) * 180/pi)
					a = a/complete
					ships[i,3] = int(a-90)
				elseif (ships[i,3] < 180) then
					ships[i,3] = ships[i,3] + 1
				elseif (ships[i,3] > 180) then
					ships[i,3] = ships[i,3] - 1
				endif

				'turn to approach
				if (ships[i,10] < 4 AND ships[i,4] < 90 AND ships[i,19] = 0) then
					ships[i,4] = ships[i,4] + 5
				endif
						
				'vertical swoop on approach
				if (ships[i,7] < 100 AND swoop = false) then
					swoop = true
					if (ships[i,19] >= 0.3 OR ships[i,20] = 0)
						ships[i,20] = 1
					elseif (ships[i,19] <= -0.3)
						ships[i,20] = 2
					endif
					if (ships[i,20] = 2)
						ships[i,19] = ships[i,19] + 0.01
					elseif (ships[i,20] = 1)
						ships[i,19] = ships[i,19] - 0.01
					endif
				endif
											
				if (ships[i,20] > 0) then
					dzb = atan(ships[i,19]) * (180/PI)
					ships[i,4] = dzb + 90
				endif
				
				'correct for negative ship rotation degrees
				if (ships[i,3] < 0) then
					ships[i,3] = ships[i,3] + 360
				elseif (ships[i,3] >= 360) then
					ships[i,3] = ships[i,3] - 360
				endif
				if (ships[i,4] < 0) then
					ships[i,4] = ships[i,4] + 360
				elseif (ships[i,4] >= 360) then
					ships[i,4] = ships[i,4] - 360
				endif

				call SpriteSetRotation(ships[i,ships[i,1]], ships[i,2],ships[i,3]+90,ships[i,4])

				if (ships[i,13] = 0) then
					x = cos((ships[i,4])*pi/180)*sin((ships[i,3])*pi/180)*speed
					y = cos((ships[i,4])*pi/180)*cos((ships[i,3])*pi/180)*speed
					z = sin((ships[i,4])*pi/180)* speed * 3
					ships[i,5] = ships[i,5] + x
					ships[i,6] = ships[i,6] + y
					ships[i,7] = ships[i,7] - z
				endif
				
				if (ships[i,7] <= 10 OR abs(ships[i,5]) > 30 OR abs(ships[i,6] > 30)) then
					if (shieldstatus = 1) then
						ships[i,13] = -1
						if (release)
							call Play(expl3)
						endif
					else
						show[i] = 0
						past = past + 1
						call SpriteIntensity(ships[i,15], 0)
						call SpriteIntensity(ships[i,14], 0)
						if lives > 0 then
							lives = lives - 1
						endif
					endif
				else
					if (ships[i,13] <= 0 AND 150-ships[i,7] <= 127) then
						call SpriteIntensity(ships[i,15], 80)			
					endif
					call SpriteTranslate(ships[i,ships[i,1]], {ships[i,5], ships[i,6], ships[i,7]})
					call SpriteTranslate(ships[i,12], {ships[i,5], ships[i,6], ships[i,7]})
				endif
			endif
		next i
		
		'Reset Ships
		if (past >= 3) then
			if (miss > 0) then
				call Sound({{3, 15}, {7, 60}, {8, 15}, {9, 10}})
			endif
			if (lives <= 0) then
				exit while
			endif
		
			warp = warp + 1
			if (warp >= 50) then
				call Play(nil)
				round = round + 1
				if ((round mod 4) = 0 AND speed < 0.6) then
					speed = speed + 0.1
				endif
				warp = -1
				past = 0
				miss = 3
				model = rand() mod 3
				cc = 1+(rand() mod 64)
				for p = 1 to UBound(ships)
					foo = NewShip(0,combinations[cc,p],model)
					for w = 1 to 11
						ships[p,w] = foo[1,w]
						call SpriteIntensity(ships[1,14], 0)				
					next w
					ships[p,13] = 0
					ships[p,19] = 0
					ships[p,20] = 0
					show[p] = 1
					call SpriteEnable(ships[p,16], false)			
					call SpriteEnable(ships[p,17], false)			
					call SpriteEnable(ships[p,18], false)
					call SpriteTranslate(ships[p,ships[p,1]], {ships[p,5], ships[p,6], ships[p,7]})
					call SpriteTranslate(ships[p,12], {ships[p,5], ships[p,6], ships[p,7]})
					call SpriteEnable(ships[p,ships[p,1]], true)
					call SpriteIntensity(ships[p,15], 50)
				next p
			else
				call ProcessZoom(warp*6)
			endif
		endif	
	endwhile
endwhile

function arrow()
	pod = {{0,0,0,0},{1,1,-2,0},{1,0,2,0},{1,-1,-2,0},{1,0,0,0}}
	for v = 1 to 5
		for d = 2 to 4
			pod[v,d] = pod[v,d]*0.4
		next d
	next v		
	return pod
endfunction

function NewReticle()
	call ReturnToOriginSprite()
	lines = {_
		{1,3,0,0},{0,2,1,0},_
		{1,2,-1,0},{0,1,0.5,0},_
		{1,1,-0.5,0},{0,0,-3,0},_
		{1,0,3,0},{0,1,2,0},_
		{1,-1,2,0},{0,0.5,1,0},_
		{1,-0.5,1,0},{0,1,-2,0},_
		{1,-1,-2,0},{0,0.5,-1,0},_
		{1,-0.5,-1,0},{0,-3,0,0},_
		{1,0,0,0},{0,-2,1,0},_
		{1,-2,-1,0},{0,-1,0.5,0},_
		{1,-1,-0.5,0},{0,0,0,0}_
		}
		for v = 1 to 22
			for d = 2 to 4
				lines[v,d] = lines[v,d]*0.2
			next d
		next v		
	return Lines3DSprite(lines)
endfunction

function missile()
	pod = {_
			{1,30,20,0},{1,35,15,0},{1,0,0,0},_
			{1,30,-20,0},{1,35,-15,0},{1,0,0,0},_
			{1,35,0,0},{1,30,0,15},{1,0,0,0},_
			{1,30,0,-15},{1,35,0,0},{1,0,0,0},_
			{1,-15,15,0},{1,-30,0,0},{1,-15,-15,0},{1,0,0,0},_
			{1,-15,0,15},{1,-30,0,0},{1,-15,0,-15},{1,0,0,0},_
			{1,-15,0,-10},{1,-15,10,0},{1,-15,0,10},{1,-15,-10,0},_
			{1,-15,0,-10},{1,-15,0,-10},{1,-15,10,0},{1,-15,0,10},_
			{1,-15,-10,0},{1,-15,0,-10}_
		}
		for v = 1 to 30
			for d = 2 to 4
				pod[v,d] = pod[v,d]*0.05
			next d
		next v		
	return pod
endfunction

function hornet()
	pod = {_
			{1,20,20,0},{1,30,20,0},{1,30,25,5},{1,20,25,5},{1,20,20,0},{1,30,20,0},_
			{1,30,-20,0},_
			{1,20,-20,0},{1,30,-20,0},{1,30,-25,5},{1,20,-25,5},{1,20,-20,0},{1,0,0,0},_
			{1,20,0,-5},{1,30,0,-5},{1,30,0,0},{1,0,0,0},_
			{1,-15,15,0},{1,-30,0,0},{1,-15,-15,0},{1,0,0,0},_
			{1,-15,0,15},{1,-30,0,0},{1,-15,0,-15},{1,0,0,0},_
			{1,-15,0,-10},{1,-15,10,0},{1,-15,0,10},{1,-15,-10,0},_
			{1,-15,0,-10},{1,-15,0,-10},{1,-15,10,0},{1,-15,0,10},_
			{1,-15,-10,0},{1,-15,0,-10}_
		}
		for v = 1 to 35
			for d = 2 to 4
				pod[v,d] = pod[v,d]*0.05
			next d
		next v		
	return pod
endfunction

function corvette()
	pod = {_
			{1,5,-10,0},{1,5,-10,5},{0,5,-10,0},_
			{1,40,-10,0},{1,40,-10,5},{0,40,-10,0},_
			{1,45,0,0},{1,45,0,5},{0,45,0,0},_
			{1,40,10,0},{1,40,10,5},{0,40,10,0},_
			{1,5,10,0},{1,5,10,5},{0,5,10,0},_
			{1,0,0,0},{1,-10,0,5},{1,5,10,5},_
			{1,65,10,5},{1,60,15,10},{1,45,15,10},{1,40,10,5},_
			{1,5,10,5},{1,-10,0,5},{1,5,-10,5},_
			{1,65,-10,5},{1,60,-15,10},{1,45,-15,10},{1,40,-10,5},_
			{1,45,0,5},{1,40,10,5},{1,5,10,5}_
		}
		for v = 1 to 32
			pod[v,2] = pod[v,2] - 20
			for d = 2 to 4
				pod[v,d] = pod[v,d]*0.05
			next d
		next v		
		pod[16,2] = 0
	return pod
endfunction

function explode()
	segment = 1
	call ReturnToOriginSprite()
	final = {{0,0,0,0}}
	for w = 1 to 15
		segx = (rand() mod 10) * 0.1
		segy = (rand() mod 10) * 0.1
		segz = (rand() mod 10) * 0.1
		rot1 = (rand() mod 360) - 180
		rot2 = (rand() mod 360) - 180
		x = cos(rot2*pi/180)*sin(rot1*pi/180)*segment
		y = cos(rot2*pi/180)*cos(rot1*pi/180)*segment
		z = sin(rot2*pi/180)* segment
		pod = {{0,segx,segy,segz},{1,segx+x,segy+y,segz+z},{0,0,0,0}};
		final = AppendArrays(final,pod)
	next w
	return final
endfunction

function shotput(sides)
    poly = RegularPolygon(sides, 0.25, 90)
    dim pod[sides * 2 + 1, 4]
    for i = 1 to sides + 1
        pod[i, 1] = poly[i, 1]
        pod[i, 2] = poly[i, 2]
        pod[i, 3] = poly[i, 3]
        pod[i, 4] = 0
    next i
    for i = 2 to sides + 1
        j = i + sides
        pod[j, 1] = poly[i, 1]
        pod[j, 2] = 0
        pod[j, 3] = poly[i, 3]
        pod[j, 4] = poly[i, 2]
    next i
	return pod
endfunction

function makescreen()
	scr = {_
			{MoveTo,0,0,40}, _
			{MoveTo,-2,6,40}, _
			{DrawTo,4,0,40}, _
			{DrawTo,-2,-6,40}, _
			{DrawTo,-4,-4,40}, _
			{DrawTo,4,4,40}, _
			{DrawTo,2,6,40}, _
			{DrawTo,-4,0,40}, _
			{DrawTo,2,-6,40}, _
			{DrawTo,4,-4,40}, _
			{DrawTo,-4,4,40}, _
			{DrawTo,-2,6,40} _
		}
	return scr
endfunction

function StarField(mode)
	dim field[5,4]
	if (mode > 0) then
		for i = 1 to 5
			call ReturnToOriginSprite()
			x = (rand() mod 10)
			y = (rand() mod 10)
			star = {{0,0,0,0},{1,0.01,0.01,0}}
			field[i,1] = Lines3DSprite(star)
			field[i,2] = x
			field[i,3] = y
			field[i,4] = 20 + (20*i)
			call SpriteTranslate(field[i,1], {field[i,2],field[i,3],field[i,4]})
		next i
	endif
	return field
endfunction

function NewShip(make,side,model)
	dim ship[1,20]
	'1  = Model Number (16,17,18)
	'2  = X rotation
	'3  = Y rotation
	'4  = Z rotation
	'5	= X position
	'6	= Y position
	'7	= Z position
	'8	= X destination
	'9  = Y destination
	'10 = Distance remaining to destination 
	'11 = Distance from origin to destination
	'12 = explode
	'13 = explode progress
	'14 = explode intensity
	'15 = ship intensity
	'16 = missle sprite
	'17 = hornet sprite
	'18 = corvette sprite
	'19 = approaching flag
	if make = 1 then
		'call ReturnToOriginSprite()
		ship[1,14] = IntensitySprite(0)
		ship[1,12] = Lines3DSprite(explode())
		call SpriteEnable(ship[1,12], false)			
		ship[1,15] = IntensitySprite(50)
		ship[1,16] = Lines3DSprite(corvette())
		ship[1,17] = Lines3DSprite(hornet())
		ship[1,18] = Lines3DSprite(missile())
		call SpriteEnable(ship[1,16], false)			
		call SpriteEnable(ship[1,17], false)			
		call SpriteEnable(ship[1,18], false)			
	endif
	ship[1,1] = model+16
	
	'rotations
	ship[1,2] = 0
	ship[1,3] = 0
	ship[1,4] = 0
	'coordinates
	if (side = 1)
		ship[1,5] = ((rand() mod 1400) / 100.0) - 7.0
		ship[1,6] = -20
	elseif (side = 2)
		ship[1,5] = ((rand() mod 1400) / 100.0) - 7.0
		ship[1,6] = 20
	elseif (side = 3)
		ship[1,5] = -20
		ship[1,6] = ((rand() mod 1400) / 100.0) - 7.0
	elseif (side = 4)
		ship[1,5] = 20
		ship[1,6] = ((rand() mod 1400) / 100.0) - 7.0
	endif
	ship[1,8] = ((rand() mod 800 ) / 100.0) - 4.0
	ship[1,9] = ((rand() mod 600 ) / 100.0) - 3.0
	
	ship[1,7] = 120
	if (ship[1,9] = ship[1,6]) then
		ship[1,9] = ship[1,9] + 1
	endif
		
	dy = ship[1,9] - ship[1,6]
	dx = ship[1,8] - ship[1,5]
	ship[1,10] = sqrt((dy*dy)+(dx*dx))
	ship[1,11] = sqrt((dy*dy)+(dx*dx))
	ship[1,13] = 0
	ship[1,19] = 0
	ship[1,20] = 0
	
    return ship
endfunction

sub titlescreen()
	call ClearScreen
	call SetFrameRate(60)
	cameraTrans = {0, 0, 0}
	call CameraTranslate(cameraTrans)	
	call ScaleSprite(64, 324 / 0.097)
	call ReturnToOriginSprite()
	tl = TextToLines("VECTORGUNNER")
	dim ta[58,4]
	for i = 1 to 28
		ta[i,1] = tl[i,1]
		ta[i,2] = (tl[i,2]*0.05)-3
		ta[i,3] = (tl[i,3]*0.05)
		ta[i,4] = 0
	next i
	for i = 29 to 58
		ta[i,1] = tl[i,1]
		ta[i,2] = (tl[i,2]*0.05)-15
		ta[i,3] = (tl[i,3]*0.05)-4
		ta[i,4] = 0
	next i
	ta = AppendArrays(ta,{{0,-5,4,0},{1,13,4,0}})
	ta = AppendArrays(ta,{{1,13,-6,0},{1,-5,-6,0},{1,-5,4,0}})
	ta = AppendArrays(ta,{{0,-5.5,4.5,0},{1,13.5,4.5,0}})
	ta = AppendArrays(ta,{{1,13.5,-6.5,0},{1,-5.5,-6.5,0}})
	ta = AppendArrays(ta,{{1,-5.5,4.5,0}})
	ts = Lines3DSprite(ta)

	distance = 820
	delay = 0
	call SpriteTranslate(ts,{-4,0,distance})
	stars = StarField(release)
	light = 80
	call IntensitySprite(light)
	while 1 do
		delay = delay + 1
		if delay = 100 then
			controls = WaitForFrame(JoystickDigital, Controller1, JoystickX + JoystickY)
			if controls[1, 6] then
				stop
			endif
			if controls[1, 5] then
				call ClearScreen()
				call ReturnToOriginSprite()
				instructions = {{-50, 90, "INSTRUCTIONS"}, _                 
				{-80, 70, "BTN 1 SHOOT"}, _                 
				{-80, 50, "BTN 2 SHIELD"}, _                 
				{-80, 30, "BTN 4 EXIT"}, _    
				{-80, 10, "PRESS BTN 1 FOR ANALOG"},_
				{-80, -10, "PRESS BTN 2 FOR DIGITAL"}}
				tl = TextListSprite(instructions) 
				while 1 do
					controls = WaitForFrame(JoystickDigital, Controller1, JoystickX + JoystickY)
					if controls[1, 4] then
						exit while
					elseif controls[1, 3] then
						joystick = JoystickAnalog
						exit while
					elseif controls[1, 6] then
						stop
					endif
				endwhile
				exit while
			endif
			if (distance > 100) then
				distance = distance - 4
				call SpriteTranslate(ts,{-4,0,distance})
				call SpriteRotate(ts,2,0,0)
			elseif (distance = 100) then
				call ReturnToOriginSprite()
				call intensitysprite(100)
				hud = { {-90,120, "SCORE: " + score},_
						{10,120, "HIGH: " + highscore}}
				ts = Text2ListSprite(hud)				
				call SpriteSetMagnification(ts,1.5)	

				distance = 99
				tftxt = {_
					{-50,-70,""},_
					{-50,-90,"PRESS 3 TO START"}_
					}
				tftxt[1,3] = "BY JSB 2018"
				tf = TextListSprite(tftxt)
			endif
			delay = 0
			for s = 1 to UBound(stars)
				if (stars[s,4] > 120)
					stars[s,4] = 20
					stars[s,2] = rand() mod 10 - 5
					stars[s,3] = rand() mod 10 - 5
				else
					stars[s,4] = stars[s,4] + 1
				endif
				call spritetranslate(stars[s,1],{stars[s,2],stars[s,3],stars[s,4]})
			next s			
		endif
	endwhile
endsub

function atan2(y,x)
	if (x > 0) then
		return 2 * atan(y/(0.01+(sqrt((x*x)+(y*y)) - x)))
	elseif (x <= 0 AND y != 0) then
		return 2 * atan((sqrt((x*x)+(y*y)) + x) / y)
	elseif (x < 0 AND y = 0) then
		return pi
	else
		return 0
	endif
endfunction

sub Dump(start, end)
    ' Set the refresh rate high. We're not drawing anything, so we can crank up the
    ' rate. To dump the Vectrex's memory, we need to send a command to the Vectrex.
    ' That happens in the WaitForFrame function. By setting the refresh rate high,
    ' WaitForFrame will finish faster and we can dump memory faster.
    call SetFrameRate(150)

    dim peekdata[2]
    while start < end
        ' Send a message to the Vectrex to peek at memory
        call Peek(start, min(16, end - start), peekdata)
        call WaitForFrame(JoystickNone, ControllerNone, JoystickNone)
        ' Wait for the array to be filled with the dumped memory
        while peekdata[1] = 0
        endwhile
        
        ' Print the results
        line = Hex(start / 0x1000) + Hex(start / 0x100 mod 16) + Hex(start / 0x10 mod 16) + hex(start mod 16) + ": "
        data = peekdata[2]
        for i = 1 to ubound(data)
            line = line + Hex(data[i] / 16) + Hex(data[i] mod 16) + " "
        next i
        print line
        start = start + 16
    endwhile
endsub

' Convert an 8 bit number to two hex digits
function Hex(i)
    if i < 10 then
        return chr(i + 48)
    else
        return chr(i - 10 + 65)
    endif
endfunction

function ProcessZoom(sequence)
    dim sweepRanges, time, range, toneIncrement, tone
    sweepRanges = {{2519, 915, 5.3}, {2062, 687, 4.6}, {1374, 229, 7.6}}
    time = float(sequence) / GetFrameRate()
    
    if time <= sweepRanges[1, 3] then
        range = 1
        rangeSequence = sequence
    elseif time <= sweepRanges[2, 3] + sweepRanges[1, 3] then
        range = 2
        rangeSequence = sequence - int(sweepRanges[1, 3] * GetFrameRate())
    elseif time <= sweepRanges[3, 3] + sweepRanges[2, 3] + sweepRanges[1, 3] then
        range = 3
        rangeSequence = sequence - int((sweepRanges[2, 3] + sweepRanges[1, 3]) * GetFrameRate())
    else
        return true
    endif
    
    toneIncrement = (sweepRanges[range, 2] - sweepRanges[range, 1]) / _
                    (sweepRanges[range, 3] * GetFrameRate())
    tone = sweepRanges[range, 1] + int(rangeSequence * toneIncrement)
    
    call Sound({{1 , tone / 256}, {0, tone mod 256}})
    
    return false
endfunction